import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { AssociateExternalConnectionRequestFilterSensitiveLog, AssociateExternalConnectionResultFilterSensitiveLog, } from "../models/models_0";
import { deserializeAws_restJson1AssociateExternalConnectionCommand, serializeAws_restJson1AssociateExternalConnectionCommand, } from "../protocols/Aws_restJson1";
var AssociateExternalConnectionCommand = (function (_super) {
    __extends(AssociateExternalConnectionCommand, _super);
    function AssociateExternalConnectionCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    AssociateExternalConnectionCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeartifactClient";
        var commandName = "AssociateExternalConnectionCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: AssociateExternalConnectionRequestFilterSensitiveLog,
            outputFilterSensitiveLog: AssociateExternalConnectionResultFilterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    AssociateExternalConnectionCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1AssociateExternalConnectionCommand(input, context);
    };
    AssociateExternalConnectionCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1AssociateExternalConnectionCommand(output, context);
    };
    return AssociateExternalConnectionCommand;
}($Command));
export { AssociateExternalConnectionCommand };
