import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeleteDomainRequestFilterSensitiveLog, DeleteDomainResultFilterSensitiveLog, } from "../models/models_0";
import { deserializeAws_restJson1DeleteDomainCommand, serializeAws_restJson1DeleteDomainCommand, } from "../protocols/Aws_restJson1";
var DeleteDomainCommand = (function (_super) {
    __extends(DeleteDomainCommand, _super);
    function DeleteDomainCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteDomainCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeartifactClient";
        var commandName = "DeleteDomainCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeleteDomainRequestFilterSensitiveLog,
            outputFilterSensitiveLog: DeleteDomainResultFilterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteDomainCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1DeleteDomainCommand(input, context);
    };
    DeleteDomainCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1DeleteDomainCommand(output, context);
    };
    return DeleteDomainCommand;
}($Command));
export { DeleteDomainCommand };
