import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeleteRepositoryPermissionsPolicyRequestFilterSensitiveLog, DeleteRepositoryPermissionsPolicyResultFilterSensitiveLog, } from "../models/models_0";
import { deserializeAws_restJson1DeleteRepositoryPermissionsPolicyCommand, serializeAws_restJson1DeleteRepositoryPermissionsPolicyCommand, } from "../protocols/Aws_restJson1";
var DeleteRepositoryPermissionsPolicyCommand = (function (_super) {
    __extends(DeleteRepositoryPermissionsPolicyCommand, _super);
    function DeleteRepositoryPermissionsPolicyCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteRepositoryPermissionsPolicyCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeartifactClient";
        var commandName = "DeleteRepositoryPermissionsPolicyCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeleteRepositoryPermissionsPolicyRequestFilterSensitiveLog,
            outputFilterSensitiveLog: DeleteRepositoryPermissionsPolicyResultFilterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteRepositoryPermissionsPolicyCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1DeleteRepositoryPermissionsPolicyCommand(input, context);
    };
    DeleteRepositoryPermissionsPolicyCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1DeleteRepositoryPermissionsPolicyCommand(output, context);
    };
    return DeleteRepositoryPermissionsPolicyCommand;
}($Command));
export { DeleteRepositoryPermissionsPolicyCommand };
