import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DisassociateExternalConnectionRequestFilterSensitiveLog, DisassociateExternalConnectionResultFilterSensitiveLog, } from "../models/models_0";
import { deserializeAws_restJson1DisassociateExternalConnectionCommand, serializeAws_restJson1DisassociateExternalConnectionCommand, } from "../protocols/Aws_restJson1";
var DisassociateExternalConnectionCommand = (function (_super) {
    __extends(DisassociateExternalConnectionCommand, _super);
    function DisassociateExternalConnectionCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DisassociateExternalConnectionCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeartifactClient";
        var commandName = "DisassociateExternalConnectionCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DisassociateExternalConnectionRequestFilterSensitiveLog,
            outputFilterSensitiveLog: DisassociateExternalConnectionResultFilterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DisassociateExternalConnectionCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1DisassociateExternalConnectionCommand(input, context);
    };
    DisassociateExternalConnectionCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1DisassociateExternalConnectionCommand(output, context);
    };
    return DisassociateExternalConnectionCommand;
}($Command));
export { DisassociateExternalConnectionCommand };
