import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetPackageVersionAssetRequestFilterSensitiveLog, GetPackageVersionAssetResultFilterSensitiveLog, } from "../models/models_0";
import { deserializeAws_restJson1GetPackageVersionAssetCommand, serializeAws_restJson1GetPackageVersionAssetCommand, } from "../protocols/Aws_restJson1";
var GetPackageVersionAssetCommand = (function (_super) {
    __extends(GetPackageVersionAssetCommand, _super);
    function GetPackageVersionAssetCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetPackageVersionAssetCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeartifactClient";
        var commandName = "GetPackageVersionAssetCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetPackageVersionAssetRequestFilterSensitiveLog,
            outputFilterSensitiveLog: GetPackageVersionAssetResultFilterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetPackageVersionAssetCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1GetPackageVersionAssetCommand(input, context);
    };
    GetPackageVersionAssetCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1GetPackageVersionAssetCommand(output, context);
    };
    return GetPackageVersionAssetCommand;
}($Command));
export { GetPackageVersionAssetCommand };
