import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetRepositoryEndpointRequestFilterSensitiveLog, GetRepositoryEndpointResultFilterSensitiveLog, } from "../models/models_0";
import { deserializeAws_restJson1GetRepositoryEndpointCommand, serializeAws_restJson1GetRepositoryEndpointCommand, } from "../protocols/Aws_restJson1";
var GetRepositoryEndpointCommand = (function (_super) {
    __extends(GetRepositoryEndpointCommand, _super);
    function GetRepositoryEndpointCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetRepositoryEndpointCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeartifactClient";
        var commandName = "GetRepositoryEndpointCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetRepositoryEndpointRequestFilterSensitiveLog,
            outputFilterSensitiveLog: GetRepositoryEndpointResultFilterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetRepositoryEndpointCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1GetRepositoryEndpointCommand(input, context);
    };
    GetRepositoryEndpointCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1GetRepositoryEndpointCommand(output, context);
    };
    return GetRepositoryEndpointCommand;
}($Command));
export { GetRepositoryEndpointCommand };
