import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListPackageVersionAssetsRequestFilterSensitiveLog, ListPackageVersionAssetsResultFilterSensitiveLog, } from "../models/models_0";
import { deserializeAws_restJson1ListPackageVersionAssetsCommand, serializeAws_restJson1ListPackageVersionAssetsCommand, } from "../protocols/Aws_restJson1";
var ListPackageVersionAssetsCommand = (function (_super) {
    __extends(ListPackageVersionAssetsCommand, _super);
    function ListPackageVersionAssetsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListPackageVersionAssetsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeartifactClient";
        var commandName = "ListPackageVersionAssetsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListPackageVersionAssetsRequestFilterSensitiveLog,
            outputFilterSensitiveLog: ListPackageVersionAssetsResultFilterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListPackageVersionAssetsCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1ListPackageVersionAssetsCommand(input, context);
    };
    ListPackageVersionAssetsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1ListPackageVersionAssetsCommand(output, context);
    };
    return ListPackageVersionAssetsCommand;
}($Command));
export { ListPackageVersionAssetsCommand };
