import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListPackageVersionDependenciesRequestFilterSensitiveLog, ListPackageVersionDependenciesResultFilterSensitiveLog, } from "../models/models_0";
import { deserializeAws_restJson1ListPackageVersionDependenciesCommand, serializeAws_restJson1ListPackageVersionDependenciesCommand, } from "../protocols/Aws_restJson1";
var ListPackageVersionDependenciesCommand = (function (_super) {
    __extends(ListPackageVersionDependenciesCommand, _super);
    function ListPackageVersionDependenciesCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListPackageVersionDependenciesCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeartifactClient";
        var commandName = "ListPackageVersionDependenciesCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListPackageVersionDependenciesRequestFilterSensitiveLog,
            outputFilterSensitiveLog: ListPackageVersionDependenciesResultFilterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListPackageVersionDependenciesCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1ListPackageVersionDependenciesCommand(input, context);
    };
    ListPackageVersionDependenciesCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1ListPackageVersionDependenciesCommand(output, context);
    };
    return ListPackageVersionDependenciesCommand;
}($Command));
export { ListPackageVersionDependenciesCommand };
