import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListPackageVersionsRequestFilterSensitiveLog, ListPackageVersionsResultFilterSensitiveLog, } from "../models/models_0";
import { deserializeAws_restJson1ListPackageVersionsCommand, serializeAws_restJson1ListPackageVersionsCommand, } from "../protocols/Aws_restJson1";
var ListPackageVersionsCommand = (function (_super) {
    __extends(ListPackageVersionsCommand, _super);
    function ListPackageVersionsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListPackageVersionsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeartifactClient";
        var commandName = "ListPackageVersionsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListPackageVersionsRequestFilterSensitiveLog,
            outputFilterSensitiveLog: ListPackageVersionsResultFilterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListPackageVersionsCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1ListPackageVersionsCommand(input, context);
    };
    ListPackageVersionsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1ListPackageVersionsCommand(output, context);
    };
    return ListPackageVersionsCommand;
}($Command));
export { ListPackageVersionsCommand };
