import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListRepositoriesRequestFilterSensitiveLog, ListRepositoriesResultFilterSensitiveLog, } from "../models/models_0";
import { deserializeAws_restJson1ListRepositoriesCommand, serializeAws_restJson1ListRepositoriesCommand, } from "../protocols/Aws_restJson1";
var ListRepositoriesCommand = (function (_super) {
    __extends(ListRepositoriesCommand, _super);
    function ListRepositoriesCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListRepositoriesCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeartifactClient";
        var commandName = "ListRepositoriesCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListRepositoriesRequestFilterSensitiveLog,
            outputFilterSensitiveLog: ListRepositoriesResultFilterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListRepositoriesCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1ListRepositoriesCommand(input, context);
    };
    ListRepositoriesCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1ListRepositoriesCommand(output, context);
    };
    return ListRepositoriesCommand;
}($Command));
export { ListRepositoriesCommand };
