import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListRepositoriesInDomainRequestFilterSensitiveLog, ListRepositoriesInDomainResultFilterSensitiveLog, } from "../models/models_0";
import { deserializeAws_restJson1ListRepositoriesInDomainCommand, serializeAws_restJson1ListRepositoriesInDomainCommand, } from "../protocols/Aws_restJson1";
var ListRepositoriesInDomainCommand = (function (_super) {
    __extends(ListRepositoriesInDomainCommand, _super);
    function ListRepositoriesInDomainCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListRepositoriesInDomainCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeartifactClient";
        var commandName = "ListRepositoriesInDomainCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListRepositoriesInDomainRequestFilterSensitiveLog,
            outputFilterSensitiveLog: ListRepositoriesInDomainResultFilterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListRepositoriesInDomainCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1ListRepositoriesInDomainCommand(input, context);
    };
    ListRepositoriesInDomainCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1ListRepositoriesInDomainCommand(output, context);
    };
    return ListRepositoriesInDomainCommand;
}($Command));
export { ListRepositoriesInDomainCommand };
