import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { PutDomainPermissionsPolicyRequestFilterSensitiveLog, PutDomainPermissionsPolicyResultFilterSensitiveLog, } from "../models/models_0";
import { deserializeAws_restJson1PutDomainPermissionsPolicyCommand, serializeAws_restJson1PutDomainPermissionsPolicyCommand, } from "../protocols/Aws_restJson1";
var PutDomainPermissionsPolicyCommand = (function (_super) {
    __extends(PutDomainPermissionsPolicyCommand, _super);
    function PutDomainPermissionsPolicyCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    PutDomainPermissionsPolicyCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeartifactClient";
        var commandName = "PutDomainPermissionsPolicyCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: PutDomainPermissionsPolicyRequestFilterSensitiveLog,
            outputFilterSensitiveLog: PutDomainPermissionsPolicyResultFilterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    PutDomainPermissionsPolicyCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1PutDomainPermissionsPolicyCommand(input, context);
    };
    PutDomainPermissionsPolicyCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1PutDomainPermissionsPolicyCommand(output, context);
    };
    return PutDomainPermissionsPolicyCommand;
}($Command));
export { PutDomainPermissionsPolicyCommand };
