import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { UpdatePackageVersionsStatusRequestFilterSensitiveLog, UpdatePackageVersionsStatusResultFilterSensitiveLog, } from "../models/models_0";
import { deserializeAws_restJson1UpdatePackageVersionsStatusCommand, serializeAws_restJson1UpdatePackageVersionsStatusCommand, } from "../protocols/Aws_restJson1";
var UpdatePackageVersionsStatusCommand = (function (_super) {
    __extends(UpdatePackageVersionsStatusCommand, _super);
    function UpdatePackageVersionsStatusCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    UpdatePackageVersionsStatusCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeartifactClient";
        var commandName = "UpdatePackageVersionsStatusCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: UpdatePackageVersionsStatusRequestFilterSensitiveLog,
            outputFilterSensitiveLog: UpdatePackageVersionsStatusResultFilterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    UpdatePackageVersionsStatusCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1UpdatePackageVersionsStatusCommand(input, context);
    };
    UpdatePackageVersionsStatusCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1UpdatePackageVersionsStatusCommand(output, context);
    };
    return UpdatePackageVersionsStatusCommand;
}($Command));
export { UpdatePackageVersionsStatusCommand };
