import { __assign, __extends } from "tslib";
import { CodeartifactServiceException as __BaseException } from "./CodeartifactServiceException";
var AccessDeniedException = (function (_super) {
    __extends(AccessDeniedException, _super);
    function AccessDeniedException(opts) {
        var _this = _super.call(this, __assign({ name: "AccessDeniedException", $fault: "client" }, opts)) || this;
        _this.name = "AccessDeniedException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, AccessDeniedException.prototype);
        return _this;
    }
    return AccessDeniedException;
}(__BaseException));
export { AccessDeniedException };
export var AllowPublish;
(function (AllowPublish) {
    AllowPublish["ALLOW"] = "ALLOW";
    AllowPublish["BLOCK"] = "BLOCK";
})(AllowPublish || (AllowPublish = {}));
export var AllowUpstream;
(function (AllowUpstream) {
    AllowUpstream["ALLOW"] = "ALLOW";
    AllowUpstream["BLOCK"] = "BLOCK";
})(AllowUpstream || (AllowUpstream = {}));
export var HashAlgorithm;
(function (HashAlgorithm) {
    HashAlgorithm["MD5"] = "MD5";
    HashAlgorithm["SHA1"] = "SHA-1";
    HashAlgorithm["SHA256"] = "SHA-256";
    HashAlgorithm["SHA512"] = "SHA-512";
})(HashAlgorithm || (HashAlgorithm = {}));
export var PackageFormat;
(function (PackageFormat) {
    PackageFormat["MAVEN"] = "maven";
    PackageFormat["NPM"] = "npm";
    PackageFormat["NUGET"] = "nuget";
    PackageFormat["PYPI"] = "pypi";
})(PackageFormat || (PackageFormat = {}));
export var ExternalConnectionStatus;
(function (ExternalConnectionStatus) {
    ExternalConnectionStatus["AVAILABLE"] = "Available";
})(ExternalConnectionStatus || (ExternalConnectionStatus = {}));
export var ResourceType;
(function (ResourceType) {
    ResourceType["ASSET"] = "asset";
    ResourceType["DOMAIN"] = "domain";
    ResourceType["PACKAGE"] = "package";
    ResourceType["PACKAGE_VERSION"] = "package-version";
    ResourceType["REPOSITORY"] = "repository";
})(ResourceType || (ResourceType = {}));
var ConflictException = (function (_super) {
    __extends(ConflictException, _super);
    function ConflictException(opts) {
        var _this = _super.call(this, __assign({ name: "ConflictException", $fault: "client" }, opts)) || this;
        _this.name = "ConflictException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ConflictException.prototype);
        _this.resourceId = opts.resourceId;
        _this.resourceType = opts.resourceType;
        return _this;
    }
    return ConflictException;
}(__BaseException));
export { ConflictException };
var InternalServerException = (function (_super) {
    __extends(InternalServerException, _super);
    function InternalServerException(opts) {
        var _this = _super.call(this, __assign({ name: "InternalServerException", $fault: "server" }, opts)) || this;
        _this.name = "InternalServerException";
        _this.$fault = "server";
        Object.setPrototypeOf(_this, InternalServerException.prototype);
        return _this;
    }
    return InternalServerException;
}(__BaseException));
export { InternalServerException };
var ResourceNotFoundException = (function (_super) {
    __extends(ResourceNotFoundException, _super);
    function ResourceNotFoundException(opts) {
        var _this = _super.call(this, __assign({ name: "ResourceNotFoundException", $fault: "client" }, opts)) || this;
        _this.name = "ResourceNotFoundException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ResourceNotFoundException.prototype);
        _this.resourceId = opts.resourceId;
        _this.resourceType = opts.resourceType;
        return _this;
    }
    return ResourceNotFoundException;
}(__BaseException));
export { ResourceNotFoundException };
var ServiceQuotaExceededException = (function (_super) {
    __extends(ServiceQuotaExceededException, _super);
    function ServiceQuotaExceededException(opts) {
        var _this = _super.call(this, __assign({ name: "ServiceQuotaExceededException", $fault: "client" }, opts)) || this;
        _this.name = "ServiceQuotaExceededException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ServiceQuotaExceededException.prototype);
        _this.resourceId = opts.resourceId;
        _this.resourceType = opts.resourceType;
        return _this;
    }
    return ServiceQuotaExceededException;
}(__BaseException));
export { ServiceQuotaExceededException };
var ThrottlingException = (function (_super) {
    __extends(ThrottlingException, _super);
    function ThrottlingException(opts) {
        var _this = _super.call(this, __assign({ name: "ThrottlingException", $fault: "client" }, opts)) || this;
        _this.name = "ThrottlingException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ThrottlingException.prototype);
        _this.retryAfterSeconds = opts.retryAfterSeconds;
        return _this;
    }
    return ThrottlingException;
}(__BaseException));
export { ThrottlingException };
export var ValidationExceptionReason;
(function (ValidationExceptionReason) {
    ValidationExceptionReason["CANNOT_PARSE"] = "CANNOT_PARSE";
    ValidationExceptionReason["ENCRYPTION_KEY_ERROR"] = "ENCRYPTION_KEY_ERROR";
    ValidationExceptionReason["FIELD_VALIDATION_FAILED"] = "FIELD_VALIDATION_FAILED";
    ValidationExceptionReason["OTHER"] = "OTHER";
    ValidationExceptionReason["UNKNOWN_OPERATION"] = "UNKNOWN_OPERATION";
})(ValidationExceptionReason || (ValidationExceptionReason = {}));
var ValidationException = (function (_super) {
    __extends(ValidationException, _super);
    function ValidationException(opts) {
        var _this = _super.call(this, __assign({ name: "ValidationException", $fault: "client" }, opts)) || this;
        _this.name = "ValidationException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ValidationException.prototype);
        _this.reason = opts.reason;
        return _this;
    }
    return ValidationException;
}(__BaseException));
export { ValidationException };
export var PackageVersionErrorCode;
(function (PackageVersionErrorCode) {
    PackageVersionErrorCode["ALREADY_EXISTS"] = "ALREADY_EXISTS";
    PackageVersionErrorCode["MISMATCHED_REVISION"] = "MISMATCHED_REVISION";
    PackageVersionErrorCode["MISMATCHED_STATUS"] = "MISMATCHED_STATUS";
    PackageVersionErrorCode["NOT_ALLOWED"] = "NOT_ALLOWED";
    PackageVersionErrorCode["NOT_FOUND"] = "NOT_FOUND";
    PackageVersionErrorCode["SKIPPED"] = "SKIPPED";
})(PackageVersionErrorCode || (PackageVersionErrorCode = {}));
export var PackageVersionStatus;
(function (PackageVersionStatus) {
    PackageVersionStatus["ARCHIVED"] = "Archived";
    PackageVersionStatus["DELETED"] = "Deleted";
    PackageVersionStatus["DISPOSED"] = "Disposed";
    PackageVersionStatus["PUBLISHED"] = "Published";
    PackageVersionStatus["UNFINISHED"] = "Unfinished";
    PackageVersionStatus["UNLISTED"] = "Unlisted";
})(PackageVersionStatus || (PackageVersionStatus = {}));
export var DomainStatus;
(function (DomainStatus) {
    DomainStatus["ACTIVE"] = "Active";
    DomainStatus["DELETED"] = "Deleted";
})(DomainStatus || (DomainStatus = {}));
export var PackageVersionOriginType;
(function (PackageVersionOriginType) {
    PackageVersionOriginType["EXTERNAL"] = "EXTERNAL";
    PackageVersionOriginType["INTERNAL"] = "INTERNAL";
    PackageVersionOriginType["UNKNOWN"] = "UNKNOWN";
})(PackageVersionOriginType || (PackageVersionOriginType = {}));
export var PackageVersionSortType;
(function (PackageVersionSortType) {
    PackageVersionSortType["PUBLISHED_TIME"] = "PUBLISHED_TIME";
})(PackageVersionSortType || (PackageVersionSortType = {}));
export var AssetSummaryFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var AssociateExternalConnectionRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var RepositoryExternalConnectionInfoFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var UpstreamRepositoryInfoFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var RepositoryDescriptionFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var AssociateExternalConnectionResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var CopyPackageVersionsRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var PackageVersionErrorFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var SuccessfulPackageVersionInfoFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var CopyPackageVersionsResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var TagFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var CreateDomainRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var DomainDescriptionFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var CreateDomainResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var UpstreamRepositoryFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var CreateRepositoryRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var CreateRepositoryResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var DeleteDomainRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var DeleteDomainResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var DeleteDomainPermissionsPolicyRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var ResourcePolicyFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var DeleteDomainPermissionsPolicyResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var DeletePackageVersionsRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var DeletePackageVersionsResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var DeleteRepositoryRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var DeleteRepositoryResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var DeleteRepositoryPermissionsPolicyRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var DeleteRepositoryPermissionsPolicyResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var DescribeDomainRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var DescribeDomainResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var DescribePackageRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var PackageOriginRestrictionsFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var PackageOriginConfigurationFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var PackageDescriptionFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var DescribePackageResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var DescribePackageVersionRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var LicenseInfoFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var DomainEntryPointFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var PackageVersionOriginFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var PackageVersionDescriptionFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var DescribePackageVersionResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var DescribeRepositoryRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var DescribeRepositoryResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var DisassociateExternalConnectionRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var DisassociateExternalConnectionResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var DisposePackageVersionsRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var DisposePackageVersionsResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var GetAuthorizationTokenRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var GetAuthorizationTokenResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var GetDomainPermissionsPolicyRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var GetDomainPermissionsPolicyResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var GetPackageVersionAssetRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var GetPackageVersionAssetResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var GetPackageVersionReadmeRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var GetPackageVersionReadmeResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var GetRepositoryEndpointRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var GetRepositoryEndpointResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var GetRepositoryPermissionsPolicyRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var GetRepositoryPermissionsPolicyResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var ListDomainsRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var DomainSummaryFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var ListDomainsResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var ListPackagesRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var PackageSummaryFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var ListPackagesResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var ListPackageVersionAssetsRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var ListPackageVersionAssetsResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var ListPackageVersionDependenciesRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var PackageDependencyFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var ListPackageVersionDependenciesResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var ListPackageVersionsRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var PackageVersionSummaryFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var ListPackageVersionsResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var ListRepositoriesRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var RepositorySummaryFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var ListRepositoriesResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var ListRepositoriesInDomainRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var ListRepositoriesInDomainResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var ListTagsForResourceRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var ListTagsForResourceResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var PutDomainPermissionsPolicyRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var PutDomainPermissionsPolicyResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var PutPackageOriginConfigurationRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var PutPackageOriginConfigurationResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var PutRepositoryPermissionsPolicyRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var PutRepositoryPermissionsPolicyResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var TagResourceRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var TagResourceResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var UntagResourceRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var UntagResourceResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var UpdatePackageVersionsStatusRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var UpdatePackageVersionsStatusResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var UpdateRepositoryRequestFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
export var UpdateRepositoryResultFilterSensitiveLog = function (obj) { return (__assign({}, obj)); };
