import { HttpRequest as __HttpRequest, HttpResponse as __HttpResponse } from "@aws-sdk/protocol-http";
import { SerdeContext as __SerdeContext } from "@aws-sdk/types";
import { AssociateExternalConnectionCommandInput, AssociateExternalConnectionCommandOutput } from "../commands/AssociateExternalConnectionCommand";
import { CopyPackageVersionsCommandInput, CopyPackageVersionsCommandOutput } from "../commands/CopyPackageVersionsCommand";
import { CreateDomainCommandInput, CreateDomainCommandOutput } from "../commands/CreateDomainCommand";
import { CreateRepositoryCommandInput, CreateRepositoryCommandOutput } from "../commands/CreateRepositoryCommand";
import { DeleteDomainCommandInput, DeleteDomainCommandOutput } from "../commands/DeleteDomainCommand";
import { DeleteDomainPermissionsPolicyCommandInput, DeleteDomainPermissionsPolicyCommandOutput } from "../commands/DeleteDomainPermissionsPolicyCommand";
import { DeletePackageVersionsCommandInput, DeletePackageVersionsCommandOutput } from "../commands/DeletePackageVersionsCommand";
import { DeleteRepositoryCommandInput, DeleteRepositoryCommandOutput } from "../commands/DeleteRepositoryCommand";
import { DeleteRepositoryPermissionsPolicyCommandInput, DeleteRepositoryPermissionsPolicyCommandOutput } from "../commands/DeleteRepositoryPermissionsPolicyCommand";
import { DescribeDomainCommandInput, DescribeDomainCommandOutput } from "../commands/DescribeDomainCommand";
import { DescribePackageCommandInput, DescribePackageCommandOutput } from "../commands/DescribePackageCommand";
import { DescribePackageVersionCommandInput, DescribePackageVersionCommandOutput } from "../commands/DescribePackageVersionCommand";
import { DescribeRepositoryCommandInput, DescribeRepositoryCommandOutput } from "../commands/DescribeRepositoryCommand";
import { DisassociateExternalConnectionCommandInput, DisassociateExternalConnectionCommandOutput } from "../commands/DisassociateExternalConnectionCommand";
import { DisposePackageVersionsCommandInput, DisposePackageVersionsCommandOutput } from "../commands/DisposePackageVersionsCommand";
import { GetAuthorizationTokenCommandInput, GetAuthorizationTokenCommandOutput } from "../commands/GetAuthorizationTokenCommand";
import { GetDomainPermissionsPolicyCommandInput, GetDomainPermissionsPolicyCommandOutput } from "../commands/GetDomainPermissionsPolicyCommand";
import { GetPackageVersionAssetCommandInput, GetPackageVersionAssetCommandOutput } from "../commands/GetPackageVersionAssetCommand";
import { GetPackageVersionReadmeCommandInput, GetPackageVersionReadmeCommandOutput } from "../commands/GetPackageVersionReadmeCommand";
import { GetRepositoryEndpointCommandInput, GetRepositoryEndpointCommandOutput } from "../commands/GetRepositoryEndpointCommand";
import { GetRepositoryPermissionsPolicyCommandInput, GetRepositoryPermissionsPolicyCommandOutput } from "../commands/GetRepositoryPermissionsPolicyCommand";
import { ListDomainsCommandInput, ListDomainsCommandOutput } from "../commands/ListDomainsCommand";
import { ListPackagesCommandInput, ListPackagesCommandOutput } from "../commands/ListPackagesCommand";
import { ListPackageVersionAssetsCommandInput, ListPackageVersionAssetsCommandOutput } from "../commands/ListPackageVersionAssetsCommand";
import { ListPackageVersionDependenciesCommandInput, ListPackageVersionDependenciesCommandOutput } from "../commands/ListPackageVersionDependenciesCommand";
import { ListPackageVersionsCommandInput, ListPackageVersionsCommandOutput } from "../commands/ListPackageVersionsCommand";
import { ListRepositoriesCommandInput, ListRepositoriesCommandOutput } from "../commands/ListRepositoriesCommand";
import { ListRepositoriesInDomainCommandInput, ListRepositoriesInDomainCommandOutput } from "../commands/ListRepositoriesInDomainCommand";
import { ListTagsForResourceCommandInput, ListTagsForResourceCommandOutput } from "../commands/ListTagsForResourceCommand";
import { PutDomainPermissionsPolicyCommandInput, PutDomainPermissionsPolicyCommandOutput } from "../commands/PutDomainPermissionsPolicyCommand";
import { PutPackageOriginConfigurationCommandInput, PutPackageOriginConfigurationCommandOutput } from "../commands/PutPackageOriginConfigurationCommand";
import { PutRepositoryPermissionsPolicyCommandInput, PutRepositoryPermissionsPolicyCommandOutput } from "../commands/PutRepositoryPermissionsPolicyCommand";
import { TagResourceCommandInput, TagResourceCommandOutput } from "../commands/TagResourceCommand";
import { UntagResourceCommandInput, UntagResourceCommandOutput } from "../commands/UntagResourceCommand";
import { UpdatePackageVersionsStatusCommandInput, UpdatePackageVersionsStatusCommandOutput } from "../commands/UpdatePackageVersionsStatusCommand";
import { UpdateRepositoryCommandInput, UpdateRepositoryCommandOutput } from "../commands/UpdateRepositoryCommand";
export declare const serializeAws_restJson1AssociateExternalConnectionCommand: (input: AssociateExternalConnectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1CopyPackageVersionsCommand: (input: CopyPackageVersionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1CreateDomainCommand: (input: CreateDomainCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1CreateRepositoryCommand: (input: CreateRepositoryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DeleteDomainCommand: (input: DeleteDomainCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DeleteDomainPermissionsPolicyCommand: (input: DeleteDomainPermissionsPolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DeletePackageVersionsCommand: (input: DeletePackageVersionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DeleteRepositoryCommand: (input: DeleteRepositoryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DeleteRepositoryPermissionsPolicyCommand: (input: DeleteRepositoryPermissionsPolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DescribeDomainCommand: (input: DescribeDomainCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DescribePackageCommand: (input: DescribePackageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DescribePackageVersionCommand: (input: DescribePackageVersionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DescribeRepositoryCommand: (input: DescribeRepositoryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DisassociateExternalConnectionCommand: (input: DisassociateExternalConnectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DisposePackageVersionsCommand: (input: DisposePackageVersionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1GetAuthorizationTokenCommand: (input: GetAuthorizationTokenCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1GetDomainPermissionsPolicyCommand: (input: GetDomainPermissionsPolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1GetPackageVersionAssetCommand: (input: GetPackageVersionAssetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1GetPackageVersionReadmeCommand: (input: GetPackageVersionReadmeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1GetRepositoryEndpointCommand: (input: GetRepositoryEndpointCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1GetRepositoryPermissionsPolicyCommand: (input: GetRepositoryPermissionsPolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListDomainsCommand: (input: ListDomainsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListPackagesCommand: (input: ListPackagesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListPackageVersionAssetsCommand: (input: ListPackageVersionAssetsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListPackageVersionDependenciesCommand: (input: ListPackageVersionDependenciesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListPackageVersionsCommand: (input: ListPackageVersionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListRepositoriesCommand: (input: ListRepositoriesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListRepositoriesInDomainCommand: (input: ListRepositoriesInDomainCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListTagsForResourceCommand: (input: ListTagsForResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1PutDomainPermissionsPolicyCommand: (input: PutDomainPermissionsPolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1PutPackageOriginConfigurationCommand: (input: PutPackageOriginConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1PutRepositoryPermissionsPolicyCommand: (input: PutRepositoryPermissionsPolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1TagResourceCommand: (input: TagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1UntagResourceCommand: (input: UntagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1UpdatePackageVersionsStatusCommand: (input: UpdatePackageVersionsStatusCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1UpdateRepositoryCommand: (input: UpdateRepositoryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const deserializeAws_restJson1AssociateExternalConnectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AssociateExternalConnectionCommandOutput>;
export declare const deserializeAws_restJson1CopyPackageVersionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CopyPackageVersionsCommandOutput>;
export declare const deserializeAws_restJson1CreateDomainCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateDomainCommandOutput>;
export declare const deserializeAws_restJson1CreateRepositoryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateRepositoryCommandOutput>;
export declare const deserializeAws_restJson1DeleteDomainCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteDomainCommandOutput>;
export declare const deserializeAws_restJson1DeleteDomainPermissionsPolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteDomainPermissionsPolicyCommandOutput>;
export declare const deserializeAws_restJson1DeletePackageVersionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeletePackageVersionsCommandOutput>;
export declare const deserializeAws_restJson1DeleteRepositoryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteRepositoryCommandOutput>;
export declare const deserializeAws_restJson1DeleteRepositoryPermissionsPolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteRepositoryPermissionsPolicyCommandOutput>;
export declare const deserializeAws_restJson1DescribeDomainCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeDomainCommandOutput>;
export declare const deserializeAws_restJson1DescribePackageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribePackageCommandOutput>;
export declare const deserializeAws_restJson1DescribePackageVersionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribePackageVersionCommandOutput>;
export declare const deserializeAws_restJson1DescribeRepositoryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeRepositoryCommandOutput>;
export declare const deserializeAws_restJson1DisassociateExternalConnectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisassociateExternalConnectionCommandOutput>;
export declare const deserializeAws_restJson1DisposePackageVersionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisposePackageVersionsCommandOutput>;
export declare const deserializeAws_restJson1GetAuthorizationTokenCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetAuthorizationTokenCommandOutput>;
export declare const deserializeAws_restJson1GetDomainPermissionsPolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetDomainPermissionsPolicyCommandOutput>;
export declare const deserializeAws_restJson1GetPackageVersionAssetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetPackageVersionAssetCommandOutput>;
export declare const deserializeAws_restJson1GetPackageVersionReadmeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetPackageVersionReadmeCommandOutput>;
export declare const deserializeAws_restJson1GetRepositoryEndpointCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetRepositoryEndpointCommandOutput>;
export declare const deserializeAws_restJson1GetRepositoryPermissionsPolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetRepositoryPermissionsPolicyCommandOutput>;
export declare const deserializeAws_restJson1ListDomainsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListDomainsCommandOutput>;
export declare const deserializeAws_restJson1ListPackagesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListPackagesCommandOutput>;
export declare const deserializeAws_restJson1ListPackageVersionAssetsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListPackageVersionAssetsCommandOutput>;
export declare const deserializeAws_restJson1ListPackageVersionDependenciesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListPackageVersionDependenciesCommandOutput>;
export declare const deserializeAws_restJson1ListPackageVersionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListPackageVersionsCommandOutput>;
export declare const deserializeAws_restJson1ListRepositoriesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListRepositoriesCommandOutput>;
export declare const deserializeAws_restJson1ListRepositoriesInDomainCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListRepositoriesInDomainCommandOutput>;
export declare const deserializeAws_restJson1ListTagsForResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTagsForResourceCommandOutput>;
export declare const deserializeAws_restJson1PutDomainPermissionsPolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutDomainPermissionsPolicyCommandOutput>;
export declare const deserializeAws_restJson1PutPackageOriginConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutPackageOriginConfigurationCommandOutput>;
export declare const deserializeAws_restJson1PutRepositoryPermissionsPolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutRepositoryPermissionsPolicyCommandOutput>;
export declare const deserializeAws_restJson1TagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<TagResourceCommandOutput>;
export declare const deserializeAws_restJson1UntagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UntagResourceCommandOutput>;
export declare const deserializeAws_restJson1UpdatePackageVersionsStatusCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdatePackageVersionsStatusCommandOutput>;
export declare const deserializeAws_restJson1UpdateRepositoryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateRepositoryCommandOutput>;
