import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CodeartifactClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeartifactClient";
import { CreateDomainRequest, CreateDomainResult } from "../models/models_0";
export interface CreateDomainCommandInput extends CreateDomainRequest {}
export interface CreateDomainCommandOutput
  extends CreateDomainResult,
    __MetadataBearer {}
export declare class CreateDomainCommand extends $Command<
  CreateDomainCommandInput,
  CreateDomainCommandOutput,
  CodeartifactClientResolvedConfig
> {
  readonly input: CreateDomainCommandInput;
  constructor(input: CreateDomainCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeartifactClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<CreateDomainCommandInput, CreateDomainCommandOutput>;
  private serialize;
  private deserialize;
}
