import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CodeartifactClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeartifactClient";
import {
  DeletePackageVersionsRequest,
  DeletePackageVersionsResult,
} from "../models/models_0";
export interface DeletePackageVersionsCommandInput
  extends DeletePackageVersionsRequest {}
export interface DeletePackageVersionsCommandOutput
  extends DeletePackageVersionsResult,
    __MetadataBearer {}
export declare class DeletePackageVersionsCommand extends $Command<
  DeletePackageVersionsCommandInput,
  DeletePackageVersionsCommandOutput,
  CodeartifactClientResolvedConfig
> {
  readonly input: DeletePackageVersionsCommandInput;
  constructor(input: DeletePackageVersionsCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeartifactClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    DeletePackageVersionsCommandInput,
    DeletePackageVersionsCommandOutput
  >;
  private serialize;
  private deserialize;
}
