import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CodeartifactClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeartifactClient";
import {
  DeleteRepositoryRequest,
  DeleteRepositoryResult,
} from "../models/models_0";
export interface DeleteRepositoryCommandInput extends DeleteRepositoryRequest {}
export interface DeleteRepositoryCommandOutput
  extends DeleteRepositoryResult,
    __MetadataBearer {}
export declare class DeleteRepositoryCommand extends $Command<
  DeleteRepositoryCommandInput,
  DeleteRepositoryCommandOutput,
  CodeartifactClientResolvedConfig
> {
  readonly input: DeleteRepositoryCommandInput;
  constructor(input: DeleteRepositoryCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeartifactClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<DeleteRepositoryCommandInput, DeleteRepositoryCommandOutput>;
  private serialize;
  private deserialize;
}
