import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CodeartifactClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeartifactClient";
import {
  DescribeRepositoryRequest,
  DescribeRepositoryResult,
} from "../models/models_0";
export interface DescribeRepositoryCommandInput
  extends DescribeRepositoryRequest {}
export interface DescribeRepositoryCommandOutput
  extends DescribeRepositoryResult,
    __MetadataBearer {}
export declare class DescribeRepositoryCommand extends $Command<
  DescribeRepositoryCommandInput,
  DescribeRepositoryCommandOutput,
  CodeartifactClientResolvedConfig
> {
  readonly input: DescribeRepositoryCommandInput;
  constructor(input: DescribeRepositoryCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeartifactClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<DescribeRepositoryCommandInput, DescribeRepositoryCommandOutput>;
  private serialize;
  private deserialize;
}
