import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CodeartifactClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeartifactClient";
import {
  GetDomainPermissionsPolicyRequest,
  GetDomainPermissionsPolicyResult,
} from "../models/models_0";
export interface GetDomainPermissionsPolicyCommandInput
  extends GetDomainPermissionsPolicyRequest {}
export interface GetDomainPermissionsPolicyCommandOutput
  extends GetDomainPermissionsPolicyResult,
    __MetadataBearer {}
export declare class GetDomainPermissionsPolicyCommand extends $Command<
  GetDomainPermissionsPolicyCommandInput,
  GetDomainPermissionsPolicyCommandOutput,
  CodeartifactClientResolvedConfig
> {
  readonly input: GetDomainPermissionsPolicyCommandInput;
  constructor(input: GetDomainPermissionsPolicyCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeartifactClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    GetDomainPermissionsPolicyCommandInput,
    GetDomainPermissionsPolicyCommandOutput
  >;
  private serialize;
  private deserialize;
}
